package uranodai.oscemote.event
{
	import flash.events.Event;
	
	import it.h_umus.osc.OSCArgument;
	import it.h_umus.osc.OSCMessage;
	import it.h_umus.osc.OSCPacket;

	public class OSCemoteCustomEvent extends Event
	{
		private var _packet:OSCPacket;
		private var _value:Array;
		
		public function OSCemoteCustomEvent(type:String, packet:OSCPacket, bubbles:Boolean=false, cancelable:Boolean=false)
		{
			super(type, bubbles, cancelable);
			this._packet = packet;
			this._value = [];
			for each (var msg:OSCMessage in packet.messages) {
				for each (var args:OSCArgument in msg.arguments) {
					_value.push(args.value);
				}
			}
		}
		
		public function get value():Array
		{
			return _value;
		}
		
		public function getValue(index:int):*
		{
			return _value[index];
		}
		
		public function get packet():OSCPacket
		{
			return _packet;
		}
		
	}
}