package uranodai.oscemote.event {
	import flash.events.Event;
	
	import it.h_umus.osc.OSCArgument;
	import it.h_umus.osc.OSCMessage;
	import it.h_umus.osc.OSCPacket;
	
	import uranodai.oscemote.model.touch.TouchData;	

	public class OSCemoteTouchEvent extends Event {

		public static const TOUCH:String = 'touch';

		private var _deviceID:String;
		private var _touch:Array;
		private var _alive:Array;
		private var _fseq:int;

		public function OSCemoteTouchEvent(type:String, packet:OSCPacket, bubbles:Boolean = false, cancelable:Boolean = false) {
			super(type, bubbles, cancelable);
			this._touch = [];
			this._alive = [];
			for (var i:int = 0; i < packet.messages.length; i++) {
				var msg:OSCMessage = packet.messages[i];
				switch (OSCArgument(msg.arguments[0]).value) {
					case 'source ':
						_deviceID = OSCArgument(msg.arguments[1]).value.toString();
						break;
					case 'set':
						this._touch.push(new TouchData(
							int(OSCArgument(msg.arguments[1]).value),
							Number(OSCArgument(msg.arguments[2]).value),
							Number(OSCArgument(msg.arguments[3]).value),
							Number(OSCArgument(msg.arguments[4]).value),
							Number(OSCArgument(msg.arguments[5]).value),
							Number(OSCArgument(msg.arguments[6]).value)
						));
						break;
					case 'fseq':
						this._fseq = int(OSCArgument(msg.arguments[1]).value);
						break;
					case 'alive':
						msg.arguments.shift();
						for each(var arg:OSCArgument in msg.arguments)
						{
							this._alive.push(arg.value);
						}
						break;
				}
			}
		}
		
		public function get deviceID():String
		{
			return this._deviceID;
		}
		
		public function getTouch(index:int):TouchData
		{
			return this._touch[index];
		}
		
		public function get alive():Array
		{
			return _alive;
		}
		
		public function get count():int {
			return this._alive.length;
		}

		public function get fseq():int {
			return this.fseq;
		}
	}
}
