﻿import mx.data.binding.ObjectDumper;
import mx.utils.Delegate;
import org.casaframework.util.XmlUtil;
import osc.OSCArgument;
import osc.OSCMessage;
import osc.OSCPacket;

/**
 * ...
 * @author ...
 */
class App 
{
	public var container:MovieClip;
	private var socket:XMLSocket;
	private var host:String;
	private var port:Number;
	
	public function App(context:Object) 
	{
		trace("tokyo marathon!")
		
		var xml:XML = new XML();
		xml.ignoreWhite = true;
		xml.onData = Delegate.create(this, onLoadXML);
		xml.load("config.xml");
		
		socket = context.socket;
		container = context.container;
		socket.onConnect = function() {
			trace("connect");
		}
		socket.onXML = Delegate.create(this, parseMessaage);
	}
	
	private function onLoadXML(data):Void
	{
		var obj:Object = XmlUtil.xmlToObject(new XML(data));
		//trace(ObjectDumper.toString(obj));
		host = obj.config[0].host;
		port = parseInt(obj.config[0].flashport);
		
		trace([host, port].toString());
		
		socket.connect(host, port);
	}
	
	function parseMessaage(xmlIn:XML):Void
	{
		//trace(">>>>" + xmlIn);
		var e = xmlIn.firstChild;
		var obj:Object = XmlUtil.xmlToObject(xmlIn);
		
		trace(ObjectDumper.toString(obj));
		
		if (obj.OSCPACKET[0].MESSAGE[0].NAME == "/tokyo_marathon/step") {
			trace("STEP " + obj.OSCPACKET[0].MESSAGE[0].ARGUMENT[0].VALUE);
			container.step_mc.step.text = obj.OSCPACKET[0].MESSAGE[0].ARGUMENT[0].VALUE;
		}
	}
}